package interfaces

import (
	"context"
	"io"

	"nf-repo/internal/model"
	"nf-repo/internal/tool/rerr"
)

type UploadHandler interface {
	UploadId() string
	Write(ctx context.Context, id string, reader io.ReadCloser, start, end int) (int, *rerr.RepositoryError)
	Done(ctx context.Context, bh BlobHandler, id string, closer io.ReadCloser, contentLength int, repo string, hash model.Hash) *rerr.RepositoryError
}
